## sendmail 8.17.1.9

=== Makefile ===
#       $Id: Makefile.dist,v 8.15 2001-08-23 20:44:39 ca Exp $

SHELL= /bin/sh
SUBDIRS= libsm libsmutil libsmdb sendmail editmap mail.local \
	 mailstats makemap praliases rmail smrsh vacation
# libmilter: requires pthread
BUILD=   ./Build
OPTIONS= $(CONFIG) $(FLAGS)

all: FRC
	@for x in $(SUBDIRS); \
	do \
		(cd $$x && echo Making $@ in: && pwd && \
		$(SHELL) $(BUILD) $(OPTIONS)) || exit; \
	done

clean: FRC
	@for x in $(SUBDIRS); \
	do \
		(cd $$x; echo Making $@ in:; pwd; \
		$(SHELL) $(BUILD) $(OPTIONS) $@); \
	done

install: FRC
	@for x in $(SUBDIRS); \
	do \
		(cd $$x && echo Making $@ in: && pwd && \
		$(SHELL) $(BUILD) $(OPTIONS) $@) || exit; \
	done

install-docs: FRC
	@for x in $(SUBDIRS); \
	do \
		(cd $$x && echo Making $@ in: && pwd && \
		$(SHELL) $(BUILD) $(OPTIONS) $@) || exit; \
	done

fresh: FRC
	@for x in $(SUBDIRS); \
	do \
		(cd $$x && echo Making $@ in: && pwd && \
		$(SHELL) $(BUILD) $(OPTIONS) -c) || exit; \
	done

$(SUBDIRS): FRC
	@cd $@; pwd; \
	$(SHELL) $(BUILD) $(OPTIONS)

FRC:

=== libsmdb/Makefile ===
#       $Id: Makefile,v 8.2 1999-09-23 22:36:29 ca Exp $

SHELL= /bin/sh
BUILD=   ./Build
OPTIONS= $(CONFIG) $(FLAGS)

all: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
clean: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
check: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
install: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@

fresh: FRC
	$(SHELL) $(BUILD) $(OPTIONS) -c

FRC:

=== cf/cf/Makefile ===
#
#  Makefile for configuration files.
#
#	$Id: Makefile,v 8.60 2005-06-14 02:16:34 gshapiro Exp $
#

#
#  Create configuration files using "m4 ../m4/cf.m4 file.mc > file.cf";
#  this may be easier than tweaking the Makefile.  You do need to
#  have a fairly modern M4 available (GNU m4 works).  On SunOS, use
#  /usr/5bin/m4.
#

# name of source for sendmail.cf (without extension)
CF=	sendmail
# name of source for submit.cf (without extension)
SUBMIT=	submit
# directory for .cf files
MAILDIR=/etc/mail
M4=	m4
CFDIR=	..
SED=  sed
ECHO= echo
CHMOD=	chmod
ROMODE=	444
RM=	rm -f
# use our own install program; should be really confINSTALL
INSTALL=../../devtools/bin/install.sh
# CF file ownership/permissions
CFOWN=root
CFGRP=bin
CFMODE=0444


.SUFFIXES:  .mc .cf

.mc.cf:
	$(RM) $@
	$(M4) ${CFDIR}/m4/cf.m4 $*.mc > $@ || ( $(RM) $@ && exit 1 )
	$(ECHO) "### $*.mc ###" >>$@
	$(SED) -e 's/^/# /' $*.mc >>$@
	$(CHMOD) $(ROMODE) $@

GENERIC=generic-bsd4.4.cf generic-hpux9.cf generic-hpux10.cf \
		generic-linux.cf generic-mpeix.cf generic-nextstep3.3.cf \
		generic-osf1.cf generic-solaris.cf \
		generic-sunos4.1.cf generic-ultrix4.cf
BERKELEY=cs-hpux9.cf cs-hpux10.cf cs-osf1.cf cs-solaris.cf \
	cs-sunos4.1.cf cs-ultrix4.cf \
	s2k-osf1.cf s2k-ultrix4.cf \
	chez.cs.cf huginn.cs.cf mail.cs.cf mail.eecs.cf mailspool.cs.cf \
	python.cs.cf ucbarpa.cf ucbvax.cf vangogh.cs.cf
OTHER=	knecht.cf
ALL=	submit.cf $(GENERIC) $(OTHER)

all: $(ALL)

berkeley: $(BERKELEY)
generic: $(GENERIC)
other: $(OTHER)

clean cleandir:
	$(RM) $(ALL) core

install:
	@echo "Before installing the .cf files please make sure you have read the"
	@echo "instructions in the file ../../INSTALL.  You should have prepared the"
	@echo "files \"submit.mc\" (supplied) and \"sendmail.mc\". Then you can use"
	@echo ""
	@echo "	make install-cf"
	@echo ""
	@echo "If you use a different name than \"sendmail\" for your main .mc file"

	@echo "then you should use"
	@echo ""
	@echo "	make install-cf CF=config"
	@echo ""
	@echo "where \"config\" is the name of your main .mc file."

install-cf:  install-sendmail-cf install-submit-cf

install-sendmail-cf: $(CF).cf
	$(INSTALL) -c -o $(CFOWN) -g $(CFGRP) -m $(CFMODE) $(CF).cf ${DESTDIR}$(MAILDIR)/sendmail.cf

install-submit-cf: $(SUBMIT).cf
	$(INSTALL) -c -o $(CFOWN) -g $(CFGRP) -m $(CFMODE) $(SUBMIT).cf ${DESTDIR}$(MAILDIR)/submit.cf

depend:

# this is overkill, but....
M4FILES=\
	${CFDIR}/domain/Berkeley.EDU.m4 \
	${CFDIR}/domain/CS.Berkeley.EDU.m4 \
	${CFDIR}/domain/EECS.Berkeley.EDU.m4 \
	${CFDIR}/domain/S2K.Berkeley.EDU.m4 \
	${CFDIR}/domain/berkeley-only.m4 \
	${CFDIR}/domain/generic.m4 \
	${CFDIR}/feature/accept_unqualified_senders.m4 \
	${CFDIR}/feature/accept_unresolvable_domains.m4 \
	${CFDIR}/feature/access_db.m4 \
	${CFDIR}/feature/allmasquerade.m4 \
	${CFDIR}/feature/always_add_domain.m4 \
	${CFDIR}/feature/authinfo.m4 \
	${CFDIR}/feature/badmx.m4 \
	${CFDIR}/feature/bcc.m4 \
	${CFDIR}/feature/bestmx_is_local.m4 \
	${CFDIR}/feature/bitdomain.m4 \
	${CFDIR}/feature/block_bad_helo.m4 \
	${CFDIR}/feature/blocklist_recipients.m4 \
	${CFDIR}/feature/check_cert_altnames.m4 \
	${CFDIR}/feature/check_other.m4 \
	${CFDIR}/feature/compat_check.m4 \
	${CFDIR}/feature/conncontrol.m4 \
	${CFDIR}/feature/delay_checks.m4 \
	${CFDIR}/feature/dnsbl.m4 \
	${CFDIR}/feature/domaintable.m4 \
	${CFDIR}/feature/enhdnsbl.m4 \
	${CFDIR}/feature/generics_entire_domain.m4 \
	${CFDIR}/feature/genericstable.m4 \
	${CFDIR}/feature/greet_pause.m4 \
	${CFDIR}/feature/ldap_routing.m4 \
	${CFDIR}/feature/limited_masquerade.m4 \
	${CFDIR}/feature/local_lmtp.m4 \
	${CFDIR}/feature/local_no_masquerade.m4 \
	${CFDIR}/feature/local_procmail.m4 \
	${CFDIR}/feature/lookupdotdomain.m4 \
	${CFDIR}/feature/loose_relay_check.m4 \
	${CFDIR}/feature/mailertable.m4 \
	${CFDIR}/feature/masquerade_entire_domain.m4 \
	${CFDIR}/feature/masquerade_envelope.m4 \
	${CFDIR}/feature/msp.m4 \
	${CFDIR}/feature/mtamark.m4 \
	${CFDIR}/feature/no_default_msa.m4 \
	${CFDIR}/feature/nocanonify.m4 \
	${CFDIR}/feature/nopercenthack.m4 \
	${CFDIR}/feature/notsticky.m4 \
	${CFDIR}/feature/nouucp.m4 \
	${CFDIR}/feature/nullclient.m4 \
	${CFDIR}/feature/prefixmod.m4 \
	${CFDIR}/feature/preserve_local_plus_detail.m4 \
	${CFDIR}/feature/preserve_luser_host.m4 \
	${CFDIR}/feature/promiscuous_relay.m4 \
	${CFDIR}/feature/queuegroup.m4 \
	${CFDIR}/feature/ratecontrol.m4 \
	${CFDIR}/feature/redirect.m4 \
	${CFDIR}/feature/relay_based_on_MX.m4 \
	${CFDIR}/feature/relay_entire_domain.m4 \
	${CFDIR}/feature/relay_hosts_only.m4 \
	${CFDIR}/feature/relay_local_from.m4 \
	${CFDIR}/feature/relay_mail_from.m4 \
	${CFDIR}/feature/require_rdns.m4 \
	${CFDIR}/feature/smrsh.m4 \
	${CFDIR}/feature/stickyhost.m4 \
	${CFDIR}/feature/sts.m4 \
	${CFDIR}/feature/tls_failures.m4 \
	${CFDIR}/feature/tls_session_features.m4 \
	${CFDIR}/feature/use_client_ptr.m4 \
	${CFDIR}/feature/use_ct_file.m4 \
	${CFDIR}/feature/use_cw_file.m4 \
	${CFDIR}/feature/uucpdomain.m4 \
	${CFDIR}/feature/virtuser_entire_domain.m4 \
	${CFDIR}/feature/virtusertable.m4 \
	${CFDIR}/hack/cssubdomain.m4 \
	${CFDIR}/hack/xconnect.m4 \
	${CFDIR}/m4/cf.m4 \
	${CFDIR}/m4/cfhead.m4 \
	${CFDIR}/m4/proto.m4 \
	${CFDIR}/m4/version.m4 \
	${CFDIR}/mailer/cyrus.m4 \
	${CFDIR}/mailer/cyrusv2.m4 \
	${CFDIR}/mailer/fax.m4 \
	${CFDIR}/mailer/local.m4 \
	${CFDIR}/mailer/mail11.m4 \
	${CFDIR}/mailer/phquery.m4 \
	${CFDIR}/mailer/pop.m4 \
	${CFDIR}/mailer/procmail.m4 \
	${CFDIR}/mailer/qpage.m4 \
	${CFDIR}/mailer/smtp.m4 \
	${CFDIR}/mailer/usenet.m4 \
	${CFDIR}/mailer/uucp.m4 \
	${CFDIR}/ostype/aix3.m4 \
	${CFDIR}/ostype/aix4.m4 \
	${CFDIR}/ostype/aix5.m4 \
	${CFDIR}/ostype/altos.m4 \
	${CFDIR}/ostype/amdahl-uts.m4 \
	${CFDIR}/ostype/a-ux.m4 \
	${CFDIR}/ostype/bsd4.3.m4 \
	${CFDIR}/ostype/bsd4.4.m4 \
	${CFDIR}/ostype/bsdi.m4 \
	${CFDIR}/ostype/bsdi1.0.m4 \
	${CFDIR}/ostype/bsdi2.0.m4 \
	${CFDIR}/ostype/darwin.m4 \
	${CFDIR}/ostype/dgux.m4 \
	${CFDIR}/ostype/domainos.m4 \
	${CFDIR}/ostype/dragonfly.m4 \
	${CFDIR}/ostype/dynix3.2.m4 \
	${CFDIR}/ostype/freebsd4.m4 \
	${CFDIR}/ostype/freebsd5.m4 \
	${CFDIR}/ostype/freebsd6.m4 \
	${CFDIR}/ostype/gnu.m4 \
	${CFDIR}/ostype/hpux10.m4 \
	${CFDIR}/ostype/hpux11.m4 \
	${CFDIR}/ostype/hpux9.m4 \
	${CFDIR}/ostype/irix4.m4 \
	${CFDIR}/ostype/irix5.m4 \
	${CFDIR}/ostype/irix6.m4 \
	${CFDIR}/ostype/isc4.1.m4 \
	${CFDIR}/ostype/linux.m4 \
	${CFDIR}/ostype/maxion.m4 \
	${CFDIR}/ostype/mklinux.m4 \
	${CFDIR}/ostype/mpeix.m4 \
	${CFDIR}/ostype/nextstep.m4 \
	${CFDIR}/ostype/openbsd.m4 \
	${CFDIR}/ostype/osf1.m4 \
	${CFDIR}/ostype/powerux.m4 \
	${CFDIR}/ostype/ptx2.m4 \
	${CFDIR}/ostype/qnx.m4 \
	${CFDIR}/ostype/riscos4.5.m4 \
	${CFDIR}/ostype/sco-uw-2.1.m4 \
	${CFDIR}/ostype/sco3.2.m4 \
	${CFDIR}/ostype/sinix.m4 \
	${CFDIR}/ostype/solaris2.m4 \
	${CFDIR}/ostype/solaris2.ml.m4 \
	${CFDIR}/ostype/solaris2.pre5.m4 \
	${CFDIR}/ostype/solaris8.m4 \
	${CFDIR}/ostype/solaris11.m4 \
	${CFDIR}/ostype/sunos3.5.m4 \
	${CFDIR}/ostype/sunos4.1.m4 \
	${CFDIR}/ostype/svr4.m4 \
	${CFDIR}/ostype/ultrix4.m4 \
	${CFDIR}/ostype/unicos.m4 \
	${CFDIR}/ostype/unicosmk.m4 \
	${CFDIR}/ostype/unicosmp.m4 \
	${CFDIR}/ostype/unixware7.m4 \
	${CFDIR}/ostype/unknown.m4 \
	${CFDIR}/ostype/uxpds.m4

$(ALL): $(M4FILES)
$(BERKELEY): $(M4FILES)
$(GENERIC): $(M4FILES)
$(OTHER): $(M4FILES)

=== debian/changelog ===
sendmail (8.17.1.9-2+deb12u2) bookworm; urgency=medium

  * QA upload
  * Use correct location for debian/NEWS.

 -- Bastien Roucariès <rouca@debian.org>  Sun, 16 Jun 2024 21:07:57 +0000

sendmail (8.17.1.9-2+deb12u1) bookworm; urgency=high

  * QA upload
  * Fix CVE-2023-51765 (Closes: #1059386):
    sendmail allowed SMTP smuggling in certain configurations.
    Remote attackers can use a published exploitation
    technique to inject e-mail messages with a spoofed
    MAIL FROM address, allowing bypass of an SPF protection
    mechanism. This occurs because sendmail supports
    <LF>.<CR><LF> but some other popular e-mail servers
    do not. This is resolved with 'o' in srv_features.
  * Enable _FFR_REJECT_NUL_BYTE for rejecting mail that
    include NUL byte
  * By default enable rejecting mail that include NUL byte.
    set confREJECT_NUL to 'true' by default .
    User could disable by setting confREJECT_NUL to false.
    (Closes: #1070190). Close a variant of CVE-2023-51765
    aka SMTP smuggling.

 -- Bastien Roucariès <rouca@debian.org>  Mon, 13 May 2024 18:44:56 +0000

sendmail (8.17.1.9-2) unstable; urgency=medium

  * QA upload.
  * Switch B-D from bsdmainutils to bsdextrautils.  (Closes: #1016431)
  * Rename qtool.8 to qtool.pl.8 to match the binary.
  * Enable _FFR_MTA_STS.  (Closes: #1027727)
  * Recommend postfix-mta-sts-resolver.
  * Update Lintian overrides.
  * Update to Standards-Version: 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Jan 2023 23:26:28 +0100

sendmail (8.17.1.9-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.  (Closes: #1009078)
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 13 Jun 2022 01:34:48 +0200

=== debian/control ===
Source: sendmail
Priority: optional
Section: mail
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends-Indep:
 groff,
 bsdextrautils,
Build-Depends:
 debhelper-compat (= 13),
 make (>> 3.79.1-14),
 m4,
 linux-libc-dev (>= 2.6.21-3) [linux-any],
 pkg-config,
 , libdb-dev, libnsl-dev, libldap2-dev, libwrap0-dev, liblockfile-dev, libsasl2-dev, libssl-dev
Build-Conflicts:
 libbind-dev,
 bind-dev,
 fakeroot (<< 0.4.5),
Rules-Requires-Root: binary-targets
Standards-Version: 4.6.2
Homepage: http://www.sendmail.org
Vcs-Browser: https://salsa.debian.org/debian/sendmail
Vcs-Git: https://salsa.debian.org/debian/sendmail.git

Package: sendmail-bin
Architecture: any
Replaces: mail-transport-agent
Provides: mail-transport-agent
Conflicts: mail-transport-agent
Pre-Depends:
 debconf,
 ${misc:Pre-Depends}
Depends:
 sendmail-base (= ${source:Version}),
 sendmail-cf (= ${source:Version}),
 procps,
 ,
 ${shlibs:Depends},
 ${perl:Depends},
 ${misc:Depends}
Recommends:
 ,
Suggests:
 sendmail-doc,
 , sasl2-bin, libsasl2-modules, openssl,
Description: powerful, efficient, and scalable Mail Transport Agent
 Sendmail is an alternative Mail Transport Agent (MTA) for Debian.
 It is suitable for handling sophisticated mail configurations,
 although this means that its configuration can also be complex.
 .
 Fortunately, simple things can be done easily, and complex things
 are possible, even if not easily understood ;)  Sendmail is the *ONLY*
 MTA with a Turing complete language to control *ALL* aspects of delivery!
 .
 Sendmail provides Security and SPAM/UCE/UBE protection via several means.
 .
 Sendmail includes *no* Mail User Agents (MUA), you'll have to
 pick from the plethora of available MUAs (mutt, vm, etc.)
 .
 This package supports REGEX, DB, NIS, NIS+, LDAP, DNS maps,
 and has enabled TCPWrappers, IPv6, LockFile, SMTP AUTH(SASL), STARTTLS(SSL).

Package: rmail
Architecture: any
Conflicts:
 postfix,
 exim,
 exim-tls,
 exim4,
 exim4-daemon-custom,
 exim4-daemon-heavy,
 exim4-daemon-light,
 courier-mta,
 smail,
 zmailer,
 masqmail,
Depends:
 sendmail-bin | mail-transport-agent,
 ${shlibs:Depends},
 ${misc:Depends}
Description: MTA->UUCP remote mail handler
 Rmail handles mail received via uucp and passes it to the local
 sendmail (or workalike).
 .
 This version comes from the sendmail source package and the only
 change is the call to sendmail (from -obq to -obi).

Package: sensible-mda
Architecture: any
Depends:
 sendmail-bin | mail-transport-agent,
 procmail | maildrop | deliver,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Mail Delivery Agent wrapper
 Sensible-mda is a Debian addition in the sendmail package and has been
 split out in hopes that it might be useful for other MTA packages.
 .
 Sensible-mda is called by the MTA, and will in turn call whichever of
 the following MDAs that it finds (in this order):
 procmail, maildrop, deliver, mail.local

Package: libmilter1.0.1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Sendmail Mail Filter API (Milter)
 The Sendmail Mail Filter API (Milter) is designed to allow third-party
 programs access to mail messages as they are being processed in order
 to filter meta-information(headers) and content.
 .
 The Debian Sendmail package is built to support libmilter.
 .
 This package contains libmilter.so

Package: libmilter-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libmilter1.0.1 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 sendmail-doc,
Description: Sendmail Mail Filter API (Milter) (development files)
 The Sendmail Mail Filter API (Milter) is designed to allow third-party
 programs access to mail messages as they are being processed in order
 to filter meta-information (headers) and content.
 .
 The Debian Sendmail package is built to support libmilter.
 .
 This is the libmilter static library and include files for development.
 .
 The documentation on building a Milter is in the sendmail-doc package.

Package: sendmail-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: powerful, efficient, and scalable Mail Transport Agent (documentation)
 Sendmail is an alternative Mail Transport Agent (MTA) for
 Debian. It is suitable for handling sophisticated mail
 configurations, although this means that its configuration
 can also be complex.
 .
 Don't try anything fancy in sendmail without using this for guidance.
 .
 Because of the complexity, you may find yourself wanting to peruse
 the documentation files included herein.  The main files are:
   cf.README.gz    -- A reference for all things in sendmail.{mc,cf}
   op.{ps,txt}.gz  -- The care and feeding of Sendmail.
   faq.txt.gz      -- Sendmail FAQ, current as of the package date.
 .
 Other files include the references for smrsh and libmilter.

Package: sendmail
Architecture: all
Depends:
 sendmail-base,
 sendmail-bin,
 sendmail-cf,
 sensible-mda,
 ${misc:Depends}
Suggests:
 sendmail-doc,
 rmail,
Description: powerful, efficient, and scalable Mail Transport Agent (metapackage)
 Sendmail is an alternative Mail Transport Agent (MTA) for Debian.
 It is suitable for handling sophisticated mail configurations,
 although this means that its configuration can also be complex.
 .
 Fortunately, simple things can be done easily, and complex things
 are possible, even if not easily understood ;)  Sendmail is the *ONLY*
 MTA with a Turing complete language to control *ALL* aspects of delivery!
 .
 Sendmail provides Security and SPAM/UCE/UBE protection via several means.
 .
 Sendmail includes *no* Mail User Agents (MUA), you'll have to
 pick from the plethora of available MUAs (mutt, vm, etc.)
 .
 This package supports REGEX, DB, NIS, NIS+, LDAP, DNS maps,
 and has enabled TCPWrappers, IPv6, LockFile, SMTP AUTH(SASL), STARTTLS(SSL).
 .
 This package is to make installation/upgrading easier (Do NOT delete it)

Package: sendmail-base
Architecture: all
Depends:
 m4,
 make,
 adduser,
 netbase,
 lockfile-progs,
 ${perl:Depends},
 ${misc:Depends}
Recommends:
 postfix-mta-sts-resolver,
Suggests:
 sendmail-doc,
 ca-certificates,
 logcheck,
 logrotate,
 resolvconf,
Description: powerful, efficient, and scalable Mail Transport Agent (arch independent files)
 Sendmail is an alternative Mail Transport Agent (MTA) for
 Debian. It is suitable for handling sophisticated mail
 configurations, although this means that its configuration
 can also be complex.
 .
 This package contains the base, architecture independent, portions
 of the sendmail packages.

Package: sendmail-cf
Architecture: all
Depends:
 m4,
 ${misc:Depends}
Suggests:
 sendmail-doc,
Description: powerful, efficient, and scalable Mail Transport Agent (config macros)
 Sendmail is an alternative Mail Transport Agent (MTA) for
 Debian. It is suitable for handling sophisticated mail
 configurations, although this means that its configuration
 can also be complex.
 .
 This package contains the .m4 (configuration files) for the
 sendmail packages.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS   = yes
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

DEB_SOURCE_PACKAGE	?= sendmail
DEB_SRCDIR		?= .
DEB_DESTDIR		?= $(CURDIR)/debian/tmp/

CFLAGS   += -fPIC
LDFLAGS  += -Wl,-z,noexecstack -Wl,--warn-shared-textrel

version_debian	?= -$(lastword $(subst -, ,${DEB_VERSION}))
SRC_DIR    := $(CURDIR)/debian
PKG_DIR    := debian/${DEB_SOURCE_PACKAGE}-bin
PKG_DOC     = debian/${DEB_SOURCE_PACKAGE}-doc${docdir}/${DEB_SOURCE_PACKAGE}-doc
SM_SUBDIRS := editmap libmilter mail.local mailstats \
		makemap praliases rmail sendmail smrsh vacation
PKG_TMP	 = debian/tmp
# this is a "magic" value since it matches "obj${prefix}.${sfx}" if it exists
# and will be used by the sendmail Build script
SM_OBJDIR	?= obj.

# Now that all that is out of the way, read the desired configuration
# settings
CONF_NAME = debian/configure.options
$(eval CONFIG_OPTS := $(shell grep -v "^\#" ${CONF_NAME}))
CONFIG_OPTS	+= ${SM_CONF_OPT}

# Include Debian Autoconf settings
include $(firstword $(wildcard debian/build/autoconf.mk \
	debian/build/autoconf.mk.in))


#-------------
# Maintainer only rule... convert upstream signature from .sig into .asc
%.asc: %.sig
	gpg -o - --enarmor $< | sed 's/ARMORED FILE/SIGNATURE/; /^Comment:/d' > $@


#-------------
# Maintainer only rule... refresh upstream signing keys
debian/upstream/signing-key.asc: HOME=import-upstream-signing-keys
debian/upstream/signing-key.asc: PGPKEYS
	mkdir import-upstream-signing-keys
	gpg --import < $<
	gpg --armor --export --export-options export-minimal,export-clean >$@
	$(RM) -r import-upstream-signing-keys


#-------------
# Maintainer only rule... refresh debian/control
control-real:
	# generate debian/configure
	dh_autoreconf
	# run twice in case debian/control gets updated
	debian/rules configure || debian/rules configure
	# cleanup
	debian/rules clean


#-------------
# Maintainer only rule... must be run in external debian directory
.PHONY: refresh-faq
refresh-faq::
	@echo 'Refreshing FAQ'
	@chmod u+w faq.txt;
	(wget --passive-ftp --timestamping \
		--cache=off http://www.sendmail.org/faq/faq.txt;);
	@chmod a-w faq.txt;
	@echo 'Refreshing Misc'
	@chmod u+w cf/feature/rhsbl.m4;
	(cd cf/feature && wget --passive-ftp --timestamping \
		--cache=off http://www.megacity.org/software_downloads/rhsbl.m4;);
	@chmod u-w cf/feature/rhsbl.m4;


#------------------------------------------------------------------------------
# Build/Package check rules
#------------------------------------------------------------------------------
#-------------
.PHONY: info
info:
	#--------------------------------------------------------------------
	# The following information will be used for this run:
	#	Source	   = ${DEB_SOURCE_PACKAGE}
	#	Package    = ${DEB_SOURCE_PACKAGE} ${DEB_VERSION}
	#	             ${version_string}${sm_custom_s}${version_debian}
	#	BuildTree  = ${DEB_SRCDIR}
	#	Arch	   = ${DEB_BUILD_ARCH} on ${DEB_HOST_ARCH}
	#	Options
	#	  configure   = ${CONFIG_OPTS}
	#	  config opt  = ${SM_CONF_OPT}
	#	  ENABLE_INDEP= ${ENABLE_INDEP}
	#	  ENABLE_ARCH = ${ENABLE_ARCH}
	#	  ENABLE_DEV  = ${ENABLE_DEV}
	#	  ENABLE_DOC  = ${ENABLE_DOC}
	#	  compile opt = ${CC} ${CFLAGS} ${DEFINES}
	#	DEB_BUILD_OPTIONS = ${DEB_BUILD_OPTIONS}
	#	DH_VERBOSE = ${DH_VERBOSE}
	#	DH_OPTIONS = ${DH_OPTIONS}
	#	DH_COMPAT  = ${DH_COMPAT}
	#--------------------------------------------------------------------


#------------------------------------------------------------------------------
# User callable rules
#------------------------------------------------------------------------------

%:
	dh $@

override_dh_auto_clean:
	$(RM) ${DEB_SRCDIR}/doc/op/op.txt
	dh_auto_clean -D debian
	$(RM) -r $(SM_OBJDIR)

configure: override_dh_auto_configure ;

override_dh_auto_configure:
	mkdir -p $(SM_OBJDIR)
	dh_auto_configure -D debian -- $(CONFIG_OPTS)

override_dh_auto_build-indep:
	#--------------------------------------------------------------------
	# build-indep:
	#
	# sendmail operations guide
	GROFF_NO_SGR=1 $(MAKE) -C ${DEB_SRCDIR}/doc/op/ op.txt
	# Debian stuff
	$(MAKE) -C debian -f Makefile build-indep
	#--------------------------------------------------------------------

override_dh_auto_install-indep:
	#--------------------------------------------------------------------
	# install-indep
	#
	# sendmail operations guide and other documentation
	${INSTALL} -d ${PKG_DOC}/op
	$(INSTALL_DATA) ${DEB_SRCDIR}/doc/op/op.ps	${PKG_DOC}/op/
	$(INSTALL_DATA) ${DEB_SRCDIR}/doc/op/op.txt	${PKG_DOC}/op/
	$(INSTALL_DATA) ${DEB_SRCDIR}/README		${PKG_DOC}/
	$(INSTALL_DATA) ${DEB_SRCDIR}/KNOWNBUGS		${PKG_DOC}/
	$(INSTALL_DATA) ${DEB_SRCDIR}/cf/README		${PKG_DOC}/cf.README
	${INSTALL} -d ${PKG_DOC}/sendmail
	$(INSTALL_DATA) ${DEB_SRCDIR}/sendmail/README		${PKG_DOC}/sendmail/
	$(INSTALL_DATA) ${DEB_SRCDIR}/sendmail/SECURITY		${PKG_DOC}/sendmail/
	$(INSTALL_DATA) ${DEB_SRCDIR}/sendmail/TRACEFLAGS	${PKG_DOC}/sendmail/
	$(INSTALL_DATA) ${DEB_SRCDIR}/sendmail/TUNING		${PKG_DOC}/sendmail/
	$(INSTALL_DATA) ${DEB_SRCDIR}/smrsh/README	${PKG_DOC}/smrsh.README
	$(INSTALL_DATA) debian/faq.txt			${PKG_DOC}/
	${INSTALL} -d ${PKG_DOC}/libmilter/html
	$(INSTALL_DATA) ${DEB_SRCDIR}/libmilter/README	${PKG_DOC}/libmilter/
	cp -a ${DEB_SRCDIR}/libmilter/docs/*		${PKG_DOC}/libmilter/html/
	# Debian stuff
	$(MAKE) -C debian/cf		-f Makefile install-indep DESTDIR="${SRC_DIR}/sendmail-cf"
	$(MAKE) -C debian/examples	-f Makefile install-indep DESTDIR="${SRC_DIR}/sendmail-base"
	$(MAKE) -C debian/local		-f Makefile install-indep DESTDIR="${SRC_DIR}/sendmail-base"
	#--------------------------------------------------------------------

override_dh_auto_build-arch:
	#--------------------------------------------------------------------
	# build-arch
	#
	# Place our m4 configuration files for the sendmail build to use
	cp -f debian/build/site.config.m4 ${DEB_SRCDIR}/devtools/Site/
	# Finally, build the whole enchilada (we'll let sendmail figure
	# which, if any of the dependant libraries each component needs)
	set -e ; \
	set -x ; \
	for subdir in ${SM_SUBDIRS}; do \
		if [ -d  ${DEB_SRCDIR}/$${subdir} ]; then \
			(cd ${DEB_SRCDIR}/$${subdir} && ./Build -S;); \
			fi; \
		done;
	# Debian stuff
	$(MAKE) -C debian -f Makefile build-arch
	# Remove our config m4 files
	$(RM) ${DEB_SRCDIR}/devtools/Site/site.config.m4
	#--------------------------------------------------------------------

override_dh_auto_install-arch:
	#--------------------------------------------------------------------
	# install-arch
	#
	# sendmail install proper... with a little help ;-}
	$(MAKE) -C ${DEB_SRCDIR}		install		DESTDIR="$(DEB_DESTDIR)"
	$(MAKE) -C ${DEB_SRCDIR}/libmilter	install		DESTDIR="$(DEB_DESTDIR)"
	$(MAKE) -C ${DEB_SRCDIR}/mail.local	force-install	DESTDIR="$(DEB_DESTDIR)"
	# Debian stuff
	$(MAKE) -C debian/sensible_mda		install-arch	DESTDIR="$(DEB_DESTDIR)"
	# Handle man pages for the sendmail aliases
	mv ${PKG_TMP}${mandir}/man5/aliases.5 \
		${PKG_TMP}${mandir}/man5/aliases.sendmail.5
	mv ${PKG_TMP}${mandir}/man1/mailq.1 \
		${PKG_TMP}${mandir}/man1/mailq.sendmail.1
	mv ${PKG_TMP}${mandir}/man1/newaliases.1 \
		${PKG_TMP}${mandir}/man8/newaliases.sendmail.8
	mv ${PKG_TMP}${mandir}/man8/sendmail.8 \
		${PKG_TMP}${mandir}/man8/sendmail.sendmail.8
	# Special handling of vacation - Debian has a seperate package
	# with a different version (sigh) keep our copy just in case...
	mv ${PKG_TMP}${libexecdir}/vacation \
		${PKG_TMP}${libexecdir}/vacation.sendmail
	mv ${PKG_TMP}${mandir}/man1/vacation.1 \
		${PKG_TMP}${mandir}/man1/vacation.sendmail.1
	${INSTALL} -d ${PKG_TMP}${libdir}/pkgconfig
	$(INSTALL_DATA) ${SRC_DIR}/milter.pc ${PKG_TMP}${libdir}/pkgconfig/milter.pc
	#--------------------------------------------------------------------

override_dh_installdocs-indep:
	# Avoid recording the build path in the documentation

=== debian/watch ===
version=4

opts="pasv,pgpsigurlmangle=s/$/.sig/" ftp://ftp.sendmail.org/pub/sendmail/sendmail\.(\S*)\.tar\.gz
opts="pasv,pgpsigurlmangle=s/$/.sig/" ftp://ftp.sendmail.org/pub/sendmail/snapshots/sendmail\.(\S*)\.tar\.gz

## sendmail 8.17.2

=== debian/changelog ===
sendmail (8.17.2-1~bpo12+1) bookworm-backports; urgency=medium

  * QA upload.
  * Rebuild for bookworm-backports.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Aug 2023 17:36:42 +0200

sendmail (8.17.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Refresh patches.
  * Use https:// instead of ftp:// URLs.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 11 Jun 2023 13:38:55 +0200

## sendmail 8.18.1

=== libsmutil/Makefile ===
#       $Id: Makefile,v 8.2 1999-09-23 22:36:32 ca Exp $

SHELL= /bin/sh
BUILD=   ./Build
OPTIONS= $(CONFIG) $(FLAGS)

all: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
clean: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
check: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
install: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@

fresh: FRC
	$(SHELL) $(BUILD) $(OPTIONS) -c

FRC:

=== test/Makefile ===
#       $Id: Makefile,v 1.2 2006-05-30 18:50:26 ca Exp $

SHELL= /bin/sh
BUILD=   ./Build
OPTIONS= $(CONFIG) $(FLAGS)

all: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
clean: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
check: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@
install: FRC
	$(SHELL) $(BUILD) $(OPTIONS) $@

fresh: FRC
	$(SHELL) $(BUILD) $(OPTIONS) -c

FRC:

=== debian/changelog ===
sendmail (8.18.1-2) unstable; urgency=medium

  * QA upload.
  * Fix building with -Werror=implicit-function-declaration.
    (Closes: #1066420)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 15 Mar 2024 01:52:07 +0100

sendmail (8.18.1-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Switch B-D from pkg-config to pkgconf.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 09 Feb 2024 12:47:28 +0100

sendmail (8.18.0.2-1) experimental; urgency=medium

  * QA upload.
  * New upstream snapshot.
  * Refresh patches.
  * Enable _FFR_REQ_CRLF and _FFR_BARE_LF.  (Closes: #1059386)
  * Add systemd unit (calling /etc/init.d/sendmail).  (Closes: #1039365)
  * Refresh upstream signing keys.
  * salsa-ci: Use --vary=domain_host.use_sudo=1.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 15 Jan 2024 13:35:18 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  make (>> 3.79.1-14),
  m4,
  linux-libc-dev (>= 2.6.21-3) [linux-any],
- pkg-config,
+ pkgconf,
  , libdb-dev, libnsl-dev, libldap2-dev, libwrap0-dev, liblockfile-dev, libsasl2-dev, libssl-dev
 Build-Conflicts:
  libbind-dev,

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/$/.sig/" https://ftp.sendmail.org/sendmail\.(\S*)\.tar\.gz
opts="pgpsigurlmangle=s/$/.sig/" https://ftp.sendmail.org/snapshots/sendmail\.(\S*)\.tar\.gz

## sendmail 8.18.2

=== debian/changelog ===
sendmail (8.18.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
    - Supports building with GCC 15.
  * Refresh patches.
  * Update to Standards-Version: 4.7.3.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 27 Jan 2026 13:35:06 +0100

sendmail (8.18.1-7) unstable; urgency=medium

  * QA upload.
  * Build with -std=gnu18.  (Closes: #1097870)
  * Fix Makefile dependencies.  (Closes: #1105656)
  * Update to Standards-Version: 4.7.2.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 11:14:36 +0200

sendmail (8.18.1-6) unstable; urgency=medium

  * QA upload.
  * Use fclose() not close() on FILE*.  (Closes: #1077408)
  * Update to Standards-Version: 4.7.0.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 04 Aug 2024 18:25:02 +0200

sendmail (8.18.1-5) unstable; urgency=medium

  * QA upload
  * Drop packaging support for older sendmail versions.
  * Build with -DDANE=1.  (Closes: #1067412)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 01 Jul 2024 10:42:43 +0200

sendmail (8.18.1-4) unstable; urgency=medium

  * QA upload
  * Use correct location for debian/NEWS.
  * Fix watch file.

 -- Bastien Roucariès <rouca@debian.org>  Sun, 16 Jun 2024 20:31:34 +0000

sendmail (8.18.1-3) unstable; urgency=medium

  * QA upload
  * Enable _FFR_REJECT_NUL_BYTE for rejecting mail that
    include NUL byte
  * By default enable rejecting mail that include NUL byte.
    set confREJECT_NUL to 'true' by default .
    User could disable by setting confREJECT_NUL to false.
    (Closes: #1070190). Close a variant of CVE-2023-51765
    aka SMTP smuggling.

 -- Bastien Roucariès <rouca@debian.org>  Mon, 13 May 2024 15:21:46 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: sendmail
-Priority: optional
 Section: mail
 Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends-Indep:
@@ -17,7 +16,7 @@
  bind-dev,
  fakeroot (<< 0.4.5),
 Rules-Requires-Root: binary-targets
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Homepage: http://www.sendmail.org
 Vcs-Browser: https://salsa.debian.org/debian/sendmail
 Vcs-Git: https://salsa.debian.org/debian/sendmail.git
